import java.util.Random;

/**

Grundisee:
Vier Quellen und vier Operationen sind repräsentiert durch 4+4 6x6x6 Kuben, in denen ein Block 3x3 markiert ist, der besagt, dass dort 
der Operator / die Quelle gelten und woanders nicht.
Der Operand ist bestimmt durch eine intersektion zwischen einer Halbsphäre in 6x6x6, einer Quelle und einem Operator.
Kann Lookup-Table erzeugt werden! Phase: 0..5 0..5 | 0..5 0..5 => bestimmte Intersektionsanzahl, 1D mit Anzahl der Intersektions 1er in Halbsphäre.
siehe Skizzen in grauem dickem Notizbuch vom Jahr 2020

int[] lookup = new int[6*6*6*6];

Berechnung des Index aus den vier Phasen, moment sind es nicht 6x6x6 Phasen PRO Kubus???
ja :-/ das wird groß!:

int[] lookup = new int[6*6*6  *6*6*6];
int[] lookup = new int[46656];

Außerdem hift es nichts, die Intersektionen von Paaren zu haben, daraus läßt sich nicht diejenige von dreien erschließen!!!
Dann aber wären es schon:
Andererseits bewegt sich ja nur 1 Quelle und 1 Operator, also doch "nur" 6x6x6 x6x6x6 Phasen.
int[] lookup = new int[6*6*6  *6*6*6];
int[] lookup = new int[46656];  // ist o.k.!, geht als Lookup-Table


Index berechnen: 
Phase qx,qy,qz von Quelle, Phase px py pz von Operation:

index = ((((pz*6+py)*6+px)*6+qz)*6+qy)*6+qx;

Lookup bilden: einfach Koordinaten beider 27-Kupsel großer Bereiche merken und den Phasen entsprechend transformieren und dann übereinstimmungen zählen, die außerdem in der
einen Halbsphäre liegen. (dies ergibt den Operanden!)

*/
public class Phasenblock
{
     public int[] lookup = new int[6*6*6  *6*6*6];
     public int[] lookdist = new int[6*6*6  *6*6*6];  //auch relative Distanz Manhatten Norm merken
     int[] vc = {0,0,0,1,1,1,1,0,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,0,1,1,1,0,1,0,1,1,0,1,1,0,0,1,1,1,0,1,0,0,0,1,0,0,0,1,0,0,0,0,1,1,1,1,1,1,0,1,1,1,0,1,0,0,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,1,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,0,1,1,1,1,1,0,1,1,1,1,1,0,1,0,0,0,1,0,1,0,0,1,0,0,1,0,1,1,1,0,1,0,1,1,1,1,0,0,1,1,1,0,0,1,0,1,1,1,1,1,1,1,0,0,0,0,1,0,0,1,1,1,1,1,1,0,0,1,1,1,1,0,0,1,1,0,0,1,1,0,0,1,1,1,0,1,0,0,0,0,0,0,1,0,1,1,1,1,0,1,0,1,1,0,1,0,0,0,1,};
     int[][] va;
     int[][] vb;
     int[][] vat;
     int[][] vbt;
     Random zufall = new Random(System.currentTimeMillis());
     
     public Phasenblock()
     {
           //vc = new int[6*6*6];
           //Random zufall = new Random(SEED);
           //for(int i=0;i<vc.length;i++)
           //    vc[i] = zufall.nextInt(2);
               
           va = new int[27][3];
           vb = new int[27][3];
           vat = new int[27][3];
           vbt = new int[27][3];
           
           for(int z=0;z<3;z++)
           {
                 for(int y=0;y<3;y++)
                 {
                      for(int x=0;x<3;x++)
                      {
                            int index = (z*3+y)*3+x;
                            va[index][0] = x;
                            va[index][1] = y;
                            va[index][2] = z;
                            vb[index][0] = x;
                            vb[index][1] = y;
                            vb[index][2] = z;
                      }
                 }
           }
           generateLookup();    
     }

     public int iabs(int x)
     {
          if(x<0)
              return -x;
          else
              return x;
     }
     
     public void generateLookup()
     {
           long t_start = System.currentTimeMillis();
       
           
           for(int pz=0;pz<6;pz++)
           {
                for(int py=0;py<6;py++)
                {
                      for(int px=0;px<6;px++)
                      {
                            for(int qz=0;qz<6;qz++)                            
                            {
                                for(int qy=0;qy<6;qy++)
                                {
                                      for(int qx=0;qx<6;qx++)
                                      {
                                            int index = ((((pz*6+py)*6+px)*6+qz)*6+qy)*6+qx;
                                            
                                            for(int inx=0;inx<27;inx++)
                                            {
                                                  vat[inx][0] = (va[inx][0] + qx)%6; //Quelle
                                                  vat[inx][1] = (va[inx][1] + qy)%6; //Quelle
                                                  vat[inx][2] = (va[inx][2] + qz)%6; //Quelle
                                                  
                                                  vbt[inx][0] = (vb[inx][0] + px)%6; //Operator
                                                  vbt[inx][1] = (vb[inx][1] + py)%6; //Operator
                                                  vbt[inx][2] = (vb[inx][2] + pz)%6; //Operator                                                  
                                            }
                                            
                                            int anz=0; //Übereinstimmende Koordinaten in der ersten halben Hemisphäre
                                            
                                            for(int inx=0;inx<27;inx++)
                                            {
                                                  for(int iny=0;iny<27;iny++)
                                                  {
                                                        if(vat[inx][0]==vbt[iny][0] && vat[inx][1]==vbt[iny][1] && vat[inx][2]==vbt[iny][2])
                                                        {
                                                             //if(vat[inx][0]<4 && vat[inx][1]<4 && vat[inx][2]<4) //1. Hemisphäre
                                                             if(vc[  (vat[inx][2]*6+vat[inx][1])*6+vat[inx][0]  ] == 1) //Zufallsbelegung
                                                             {
                                                                   anz++;
                                                             }
                                                          
                                                             break;
                                                        }
                                                  }
                                            }
                                            
                                            lookup[index] = anz;
                                            lookdist[index] = iabs(vat[vat.length/2][0]-vbt[vbt.length/2][0]) +iabs(vat[vat.length/2][1]-vbt[vbt.length/2][1]) +iabs(vat[vat.length/2][2]-vbt[vbt.length/2][2]); 
                                      }
                                }
                            }                            
                      }
                }
           }
           
           long t_end = System.currentTimeMillis();
           
           println("Duration of this calculation: "+(t_end-t_start)+"ms");  // ca. 150ms, ist o.k.
           
     }
     
     /**
     form: 4 Zeilen, 10 Spalten, 5 Operationen, Ranfolge: * / + - %
     phase: quelle 0..3 mit je 3 Spalten, Operator 0..3 mit je 3 Spalten => 4*3 + 5*3 == 27 Spalten bei phase 
     Permutation der Operationen extra: 0..23?
     // 0123 4*3*2*1 = 24 Mögl.
     */
     int[] dist = {0,0,0,0,0};
     int[] ix = {0,0,0,0,0};     
     int maxindex()
     {
          int inx=dist.length-1;
          int dmax = dist[dist.length-1];
          for(int i=dist.length-1;i>=0;i--)
          {
                if(dist[i]>=dmax)
                {
                     dmax = dist[i];
                     inx=i;
                }
          }
          return inx;
     }
     
     public void sortinx()
     {
           for(int i=0;i<ix.length;i++)
              ix[i] = i;
              
           for(int i=0;i<dist.length;i++)
           {
                ix[i] = maxindex();
                dist[ix[i]]=-1;
           }
     }
     
     public void phase2form(int[] p, int[][] form)
     {
           for(int i=0;i<4;i++) //Quellen == Zeile bei form
           {
                 int p0 = p[i*3+0];   
                 int p1 = p[i*3+1];   
                 int p2 = p[i*3+2];   
                 for(int k=4;k<9;k++)
                 {
                       int p3 = p[k*3+0];
                       int p4 = p[k*3+1];
                       int p5 = p[k*3+2];
                       dist[k-4] = lookdist[ ((((p5*6+p4)*6+p3)*6+p2)*6+p1)*6+p0 ];
                 }
                 sortinx();
       //println("test sort: "+ix[0]+" "+ix[1]+" "+ix[2]+" "+ix[3]+" "+ix[4]);                 
                 for(int k=0;k<5;k++)
                 {
                       form[i][k*2] = ix[k];
                       int p3 = p[(4+ix[k])*3+0];
                       int p4 = p[(4+ix[k])*3+1];
                       int p5 = p[(4+ix[k])*3+2];
                       form[i][k*2+1] = lookup[ ((((p5*6+p4)*6+p3)*6+p2)*6+p1)*6+p0 ];
                 }
           }
     }

     public int[] randomPhase()
     {
           int[] p = new int[27];
           for(int i=0;i<p.length;i++)
               p[i] = zufall.nextInt(6);
           return p;    
     }
     
     public int[][] emptyFormula()
     {
           return new int[4][10];
     }
     
     
     int[] savephase = randomPhase();
     public void changePhase(int[] p)
     {
          for(int i=0;i<p.length;i++)
              savephase[i] = p[i];
          for(int i=0;i<3;i++)
          {
            if(zufall.nextBoolean())
            {
                int x = zufall.nextInt(p.length);
                int inc = zufall.nextInt(6);
                p[x]+=inc;
                p[x]%=6;
            }
          }   
     }
     
     public void unchangePhase(int[] p)
     {
          for(int i=0;i<p.length;i++)
              p[i] = savephase[i];
     }
     
     int addAll(int[][] form)
     {
           int sum = 0;
           for(int i=0;i<form.length;i++)
               for(int k=0;k<form[i].length;k++)
                   sum+=form[i][k];
           return sum;        
     }
}
